'****************************************************************
'*  CTRLCARD.BAS                                                *
'*                                                              *
'*  By        : Bernard LECLERC                                 *
'*  Notice    : Copyright (c) 2000 Feelgood Labs, Inc.          *
'*              All Rights Reserved                             *
'*  Date      : 26/11/00                                        *
'*  Version   : 1.01                                            *
'*  Revision  : 15/12/00                                        *
'*  Notes     : Limitation d'acces ou de temps par carte        *
'*              I2C avec fonctions predefinies par programme    *
'****************************************************************



'Definition des variables

B0      VAR     BYTE
B1      VAR     BYTE
B2      VAR     BYTE
B3      VAR     BYTE
N       VAR     BYTE
addr    VAR     BYTE


'Affectation des ports

D4      VAR     PORTA.0
D5      VAR     PORTA.1
D6      VAR     PORTA.2
D7      VAR     PORTA.3
RS      VAR     PORTA.4

SW      VAR     PORTB.0
SDA     VAR     PORTB.1
SCL     VAR     PORTB.2
EN      VAR     PORTB.3
RLY     VAR     PORTB.4
BUZ     VAR     PORTB.5
FR0     VAR     PORTB.6
FR1     VAR     PORTB.7


'Direction des ports

TRISB  =%00000001
TRISA  =0

'Detection d'une carte inserree

debut:  RLY = 0
        LCDOut $FE, 1, " INSEREZ VOTRE",$FE,$C0,"    CARTE !"
detec:  IF SW=1 Then loop
        GoTo detec


'Programme principal

loop:   Sound buz,[100,60]
        addr = $03
        GoSub lect
        If B0 = "a" Then acces
        If B0 = "c" Then compt
        If B0 = "t" Then compt
        If B0 = "d" Then decod
        GoTo ejec

affi:   LCDOut $FE, 1
        For N = $10 to $1F
        addr = N
        GoSub lect
        LCDOut B0
        Next N
        LCDOut $FE, $C0
        For N = $20 to $2F
        addr = N
        GoSub lect
        LCDOut B0
        Next N
        Return




'Autorisation d'acces
acces:  addr = $00
        GoSub lect
        If B0 <> $20 then ejec
        RLY = 1
        GoSub affi
        addr = $04
        GoSub lect
        If B0 = "p" then cart
        Pause 3000
        Goto debut

cart:   If SW = 0 then debut        
        addr = $03
        GoSub lect
        If B0 = "t" Then time
        GoTo cart


'Comptage d'utilisation
compt:  addr = $00
        GoSub lect
        B1 = B0
        addr = $01
        GoSub lect
        B2 = B0
        addr = $02
        GoSub lect
        B3 = B0
        GoSub decomp
        RLY = 1
        addr = $00
        B0 = B1
        GoSub ecri
        addr = $01
        B0 = B2
        GoSub ecri
        addr = $02
        B0 = B3
        GoSub ecri
        GoSub Affi
        LCDOut $FE, $C0, B1,B2,B3
        GoTo cart

Decomp: If B1 = $30 and B2 = $30 and B3 = $30 then ejec
        B3 = B3 - 1
        If B3 < "0" then
        B3 = "9"
        B2 = B2 - 1
        EndIf
        If B2 < "0" then
        B2 = "9"
        B1 = B1 - 1
        Endif
        If B1 > $39 or B2 > $39 or B3 > $39 then ejec
        If B1 < $30 or B2 < $30 or B3 < $30 then ejec
        Return

'Temp d'utilisation
time:   addr = $04
        GoSub lect
        If B0 = "d" then
        Pause 10000
        EndIF
        If B0 = "m" then
        Pause 60000
        EndIF
        If B0 = "h" then
        For N= 0 To 60
        Pause 60000
        Next N
        EndIF
        GoTo compt

'Decodeur de niveau
decod:  addr = $00
        GoSub lect
        B1 = B0
        I2CWrite sda,scl,$41,$00,[B0]
        Gosub affi
        LCDOut $FE, $C0, B1
        Pause 3000
        GoTo debut


'Ecriture d'un octet sur la carte

ecri:   I2CWrite sda,scl,$A0,addr,[B0]
        Pause 20
        Return


'Lecture d'un octet sur la carte

lect:   I2CRead sda,scl,$A0,addr,[B0]
        Pause 20
        Return


'Carte non reconnue                 
ejec:   LCDOut $FE, 1, "Carte Epuisee",$FE, $C0,"Ou Non Valable!"
        Sound buz,[50,300]
        Pause 3000
        GoTo  debut

        End
